var request = require("request");
var jetpack = require("fs-jetpack");
var opn = require("opn");
var os = require("os");

var dmg = require("dmg");
var pat = require("path");
var fs = require("fs");
var rt = jetpack.cwd(pat.join(os.homedir(),".hq"))


const install = (cb) => new Promise((resolve, reject) => {

  rt.file("rethink.dmg");
  var r = request("https://download.rethinkdb.com/osx/rethinkdb-2.3.5.dmg")
  r.pipe(rt.createWriteStream("rethink.dmg"))
  var i = 0;
  r.on("data",() => {
    cb({
      current : i++,
      total : 1050
    })
  })
  r.on("end",function(){
    dmg.mount(rt.path("rethink.dmg"),(err,path) => {
      opn(pat.join(path,fs.readdirSync(path).filter(k => k.indexOf(".pkg") > 0)[0])).then(() => {
        console.log("installer done");
        rt.remove("rethink.dmg");
        resolve();
      })
    })
  })
})

var spawn = require('cross-spawn');

const run = () => new Promise((resolve, reject) => {
  //  spawn.on('error', reject)
  var s = spawn('rethinkdb', [], {cwd : pat.join(os.homedir(),".hq")});
  s.on('error',reject)
  s.stdio[1].on('data', function(d){
    if (d.toString().indexOf("Server ready,") === 0) resolve()
  })
})

module.exports = {
  start : run,
  install : install
}

const init = module.exports = (cb) => run().catch(e => install(cb).then(run)).then(() => console.log("rethink done"))
